-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}


local function onReset()
  electrics.values['rotater'] = 0
  electrics.values['rotater_input'] = 0
  electrics.values['lifter'] = 0
  electrics.values['lifter_input'] = 0
end

local function updateGFX(dt) -- ms
  electrics.values['lifter'] = math.min(1, math.max(-0.0, (electrics.values['lifter'] + electrics.values['lifter_input'] * dt * 0.2)))
  electrics.values['rotater'] = math.min(1, math.max(-1.0, (electrics.values['rotater'] + electrics.values['rotater_input'] * dt * 0.2)))
end

local function rotateTurret(value)
  electrics.values.rotater_input = value
end

local function liftGun(value)
  electrics.values.lifter_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.rotateTurret = rotateTurret
M.liftGun = liftGun

return M
